package com.pvuv.pvuv;

import com.google.common.collect.Lists;
import com.google.gson.Gson;
import com.pvuv.pvuv.model.MiniprogramUv;
import com.pvuv.pvuv.util.DateUtil;
import com.pvuv.pvuv.util.SystemConstant;
import com.pvuv.pvuv.util.WechatUtils;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;
import org.apache.commons.io.FileUtils;
import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.chrome.ChromeDriver;
import org.openqa.selenium.chrome.ChromeOptions;
import org.openqa.selenium.firefox.FirefoxDriver;
import org.openqa.selenium.firefox.FirefoxProfile;
import org.openqa.selenium.firefox.internal.ProfilesIni;

import java.io.File;
import java.io.IOException;
import java.util.*;
import java.util.concurrent.TimeUnit;


public class Uvpv {
    private static String webDriver = "webdriver.chrome.driver";
    private static String webDriverPath ="D:\\google\\chromedriver.exe";
    private static String taobaourl = "https://sycm.taobao.com/portal/home.htm";
    private static String jdurl = "https://sz.jd.com/sz/view/indexs.html";
    private static String redurl = "https://ark.xiaohongshu.com/";
    private static String umengurl = "https://passport.umeng.com/login";
    private static WebDriver driver = null;

    public static List<String> getUP(int shopid) {
        String userName = "";
        String passWord = "";
        switch (shopid) {
            case 1:
                userName = "charleskeith箱包旗舰店";
                passWord = "ckshsuperbag@2019";
                break;
            case 2:
                userName = "charleskeith旗舰店";
                passWord = "ckshshoesbags8@2020";
                break;
            case 3:
                userName = "social.china@charleskeith.com";
                passWord = "Charleskeith@2019";
                break;
            case 4:
                userName = " jd_clk";
                passWord = "ckshjd@1996";
                break;
            case 13:
                userName = "ck_red@163.com";
                passWord = "ckshred@1808";
                break;
            case 15:
                userName = "social.china@charleskeith.com";
                passWord = "Charleskeith@2019";
                break;
            case 16:
                userName = "pedro旗舰店";
                passWord = "pedro@2019";
                break;
            case 18:
                userName = "pedro_red@163.com";
                passWord = "pedrored@2020";
                break;
            case 19:
                userName = "pedro旗舰店";
                passWord = "newjd@2020";
                break;
            case 20:
                userName = "616509";
                passWord = "CKsh@0810";
                break;
            case 21:
                userName = "616509";
                passWord = "CKsh@0810";
                break;
        }
        List<String> list = new ArrayList<>();
        list.add(userName);
        list.add(passWord);
        return list;
    }


    private static String filePath = "D:\\pvuv.txt";

    public static void writeFile(String content) {
        try {
            FileUtils.writeByteArrayToFile(new File(filePath), content.getBytes(), true);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        File file = new File(filePath);
        if (file.exists()) {
            FileUtils.deleteQuietly(file);
        }
//        int[] intArray = new int[]{3,15};
//        int[] intArray = new int[]{13,18};
//        int[] intArray = new int[]{4,19};
//        int[] intArray = new int[]{13,18,3,15};
        int[] intArray = new int[]{13,18,4,19,3,15};
//        int[] intArray = new int[]{1,2,3,4,13,15,16,18,19};
        for (int shopid : intArray) {
            start(shopid);
        }

        if (driver != null) {
            driver.quit();
        }
    }


    /**
     * 方法描述: 启动
     *
     * @throws
     * @author tarzan Liu
     * @date 2020年08月07日 12:42:02
     * @param shopid
     */
    public static void start(int shopid) {
        try {
            if (Objects.isNull(driver) && shopid != 3 && shopid != 15) {
                System.setProperty(webDriver, webDriverPath);
                ChromeOptions options = new ChromeOptions();
                options.addArguments("Accept=text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8");
                options.addArguments("Accept-Encoding=gzip, deflate, sdch");
                options.addArguments("Accept-Language=zh-CN,zh;q=0.8");
                options.addArguments("Connection=keep-alive");
                options.addArguments("Host=activityunion-marketing.meituan.com");
                options.addArguments("Upgrade-Insecure-Requests=1");
                options.addArguments("User-Agent=Mozilla/5.0 (iPhone; CPU iPhone OS 8_0 like Mac OS X) AppleWebKit/600.1.3 (KHTML, like Gecko) Version/8.0 Mobile/12A4345d Safari/600.1.4");
//                options.setExperimentalOption("debuggerAddress", "127.0.0.1:9222");
                List<String> excludeSwitches = Lists.newArrayList("enable-automation");
                options.setExperimentalOption("excludeSwitches", excludeSwitches);
                driver = new ChromeDriver(options);
                String title = "shopid,uv,pv,miniUV,miniPV\r\n";
                System.out.println(title);
                writeFile(title);
            }
            Map<String,String> map = new HashMap<>();
            if (shopid == 1 || shopid == 2 || shopid == 16) {
                getTaoBaoPv(driver, map, shopid);
//            if (shopid == 3 || shopid == 15)
//                getEsitePv(driver, map, shopid);
            }
            if (shopid == 4 || shopid == 19 ) {
                getJDPv(driver, map, shopid);
            }
            if (shopid == 13 || shopid == 18 ) {
                getREDPv(driver, map, shopid);
            }
            if (shopid == 3 || shopid == 15) {
                FirefoxProfile profile = new ProfilesIni().getProfile("default");
                WebDriver driverEsite = new FirefoxDriver(profile);
                getEsitePv(driverEsite, map, shopid);
            }

            String uv = map.get("uv") == null ? "" : map.get("uv");
            String pv = map.get("pv") == null ? "" : map.get("pv");
            String miniUV = map.get("miniUV") == null ? "" : map.get("miniUV");
            String miniPV = map.get("miniPV") == null ? "" : map.get("miniPV");
            String content = shopid + "," + uv + ","  + pv + "," + miniUV + "," + miniPV + "\r\n";
            System.out.println(content);
            writeFile(content);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (Objects.nonNull(driver)) {
                //  driver.close();
            }
        }

    }

    /**
     * 获取 小红书 pv uv
     */
    private static void getREDPv(WebDriver webDriver, Map<String, String> map, int shopid) throws Exception{
        userLogin(driver, shopid);
//        if(driver.findElements(By.xpath("/html/body/div[6]/div/div/div/div[2]/div/div[2]/div/div[2]/button[1]/span")).size() > 0){
//            WebElement bulletFrame = driver.findElement(By.xpath("/html/body/div[6]/div/div/div/div[2]/div/div[2]/div/div[2]/button[1]/span"));
//            bulletFrame.click();
//        } else {
//            System.out.println("");
//        }
        Thread.sleep(3000);
        WebElement dateWebElement = driver.findElement(By.xpath("//a[contains(@href,'/ark/sale-data/item')]"));
        dateWebElement.click();
        Thread.sleep(3000);
        try {
            WebElement flowWebElement = driver.findElement(By.xpath("//a[contains(@href,'/ark/sale-data/item/traffic-data')]"));
            flowWebElement.click();
        }catch (Exception e){

        }
        Thread.sleep(1000);
        webDriver.manage().timeouts().implicitlyWait(1000, TimeUnit.SECONDS);
        String pv_value = webDriver.findElement(By.xpath("//*[@id=\"app\"]/div/div[1]/div/div/div/div/div/div/div/div[3]/div[2]/div/div/span")).getText();
        String uv_value = webDriver.findElement(By.xpath("//*[@id=\"app\"]/div/div[1]/div/div/div/div/div/div/div/div[3]/div[1]/div/div/span")).getText();
        map.put("uv",uv_value.replace(",", ""));
        map.put("pv",pv_value.replace(",", ""));
        WebElement arrowWebElement = driver.findElement(By.className("user-info"));
        arrowWebElement.click();
        WebElement btnWebElement = driver.findElement(By.xpath("//*[text()='退出']"));
        btnWebElement.click();
        Thread.sleep(3000);
    }

    /**
     * 获取 京东 pv uv
     */
    private static void getJDPv(WebDriver webDriver, Map<String, String> map, int shopid) throws Exception{
        userLogin(driver, shopid);
        Thread.sleep(10000);
        webDriver.manage().timeouts().implicitlyWait(10, TimeUnit.SECONDS);
        String pv_value = webDriver.findElement(By.xpath("//*[@id=\"coreIndex\"]/div[2]/div[1]/ul/li[2]/div[2]/div")).getText();
        String uv_value = webDriver.findElement(By.xpath("//*[@id=\"coreIndex\"]/div[2]/div[1]/ul/li[1]/div[2]/div")).getText();
        map.put("uv",uv_value.replace(",", ""));
        map.put("pv",pv_value.replace(",", ""));
//        WebElement arrowWebElement = driver.findElement(By.className("user awe-angel-down"));
        WebElement arrowWebElement = driver.findElement(By.xpath("//span[contains(@class,'user awe-angel-down')]"));
        arrowWebElement.click();
        WebElement btnWebElement = driver.findElement(By.xpath("//a[contains(@href,'logout')]"));
        btnWebElement.click();
        Thread.sleep(3000);
    }

    /**
     * 获取淘宝pv uv
     *
     * */
    private static void getTaoBaoPv(WebDriver webDriver, Map<String, String> map, int shopid) throws Exception {
        userLogin(driver, shopid);
        Thread.sleep(15000);
        driver.get("https://sycm.taobao.com/portal/home.htm");
        webDriver.manage().timeouts().implicitlyWait(10, TimeUnit.SECONDS);
        Thread.sleep(3000);
        String pv_value = webDriver.findElement(By.xpath("//*[@id=\"live-survey-false\"]/div[2]/div/div[2]/div/div[1]/div[2]/p[3]/span[2]")).getText();
        String uv_value = webDriver.findElement(By.xpath("//*[@id=\"live-survey-false\"]/div[2]/div/div[2]/div/div[3]/div[2]/p[2]/span[2]")).getText();
        map.put("uv",uv_value.replace(",", ""));
        map.put("pv",pv_value.replace(",", ""));
        WebElement btnWebElement = driver.findElement(By.xpath("//*[@id=\"app\"]/div/div[1]/div[1]/section[1]/div/div[3]/a"));
        btnWebElement.click();
        Thread.sleep(3000);
    }

    //    static String strHead = "<html><head></head><body><pre style=\"word-wrap: break-word; white-space: pre-wrap;\">";
    static String strHead = "<html xmlns=\"http://www.w3.org/1999/xhtml\"><head><link title=\"将较长的行自动换行\" href=\"resource://gre-resources/plaintext.css\" type=\"text/css\" rel=\"alternate stylesheet\" /></head><body><pre>";
    static String strLast = "</pre></body></html>";

    /**
     * 获取官网pv uv
     *
     * */
    private static void getEsitePv(WebDriver webDriver, Map<String, String> map, int shopid) throws Exception {
        userLogin(webDriver, shopid);
        if (shopid == 3) {
            Thread.sleep(1000);
            webDriver.get("https://web.umeng.com/main.php?c=site&a=frame&siteid=1258653523");
            Thread.sleep(5000L);
            webDriver.get("https://web.umeng.com/main.php?c=site&a=overview&ajax=module%3Dsummary&siteid=1258653523&_=1584329985806");
            String json = webDriver.getPageSource();
            String jsonStr = json.substring(strHead.length(), json.length() - strLast.length());
            JSONObject jsonObject = JSONObject.fromObject(jsonStr);
            if (null != jsonObject) {
                Object o = jsonObject.get("data");
                if (null != o) {
                    JSONObject res = (JSONObject) o;
                    Object summary = res.get("summary");
                    if (null != summary) {
                        JSONObject summaryJSON = (JSONObject) summary;
                        if (null != summaryJSON) {
                            JSONArray jsonArray = summaryJSON.getJSONArray("items");
                            if (null != jsonArray) {
                                JSONObject result = (JSONObject) jsonArray.get(1);
                                String pv_value = result.getString("pv");
                                String uv_value = result.getString("uv");
                                map.put("uv",uv_value);
                                map.put("pv",pv_value);
                            }
                        }
                    }
                }
            }

            webDriver.get("http://api.umeng.com/yesterday_data?appkey=5537103667e58eb776001821&auth_token=n8FodCvgRIqBdX1JEztt");
            String jsonIos = webDriver.getPageSource();
            String jsonStrIos = jsonIos.substring(strHead.length(), jsonIos.length() - strLast.length());
            JSONObject jsonObjectIos = JSONObject.fromObject(jsonStrIos);
            if (null != jsonObjectIos) {
                String uvIos = jsonObjectIos.getString("active_users");
                String puIos = jsonObjectIos.getString("launches");
                if (null != uvIos) {
                    if (map.get("uv") != null && map.get("pv") != null) {
                        map.put("uv", String.valueOf(Integer.parseInt(map.get("uv")) + Integer.parseInt(uvIos)));
                        map.put("pv", String.valueOf(Integer.parseInt(map.get("pv")) + Integer.parseInt(puIos)));
                    }
                    webDriver.get("http://api.umeng.com/yesterday_data?appkey=552ca86efd98c5f44100000c&auth_token=n8FodCvgRIqBdX1JEztt");
                    String jsonAd = webDriver.getPageSource();
                    String jsonStrAd = jsonAd.substring(strHead.length(), jsonAd.length() - strLast.length());
                    JSONObject jsonObjectAd = JSONObject.fromObject(jsonStrAd);
                    if (null != jsonObjectAd) {
                        String uvAd = jsonObjectAd.getString("active_users");
                        String puAd = jsonObjectAd.getString("launches");
                        if (null != uvAd) {
                            if (map.get("uv") != null && map.get("pv") != null) {
                                map.put("uv", String.valueOf(Integer.parseInt(map.get("uv")) + Integer.parseInt(uvAd)));
                                map.put("pv", String.valueOf(Integer.parseInt(map.get("pv")) + Integer.parseInt(puAd)));
                            }
                        }
                    }
                }
            }

            String ckWechatDate = WechatUtils.getWeChatData(WechatUtils.getAccessToken(), DateUtil.format(DateUtil.getYesterday(), SystemConstant.FORMAT_DATE_YYMMDD),DateUtil.format(DateUtil.getYesterday(),SystemConstant.FORMAT_DATE_YYMMDD));
            parseJson(ckWechatDate, map);
        } else if (shopid == 15) {
            webDriver.get("https://web.umeng.com/main.php?c=site&a=frame&siteid=1263531609");
            Thread.sleep(5000L);
            webDriver.get("https://web.umeng.com/main.php?c=site&a=overview&ajax=module%3Dsummary&siteid=1263531609&_=1470274565304");
            String json = webDriver.getPageSource();
            String jsonStr = json.substring(strHead.length(), json.length() - strLast.length());
            JSONObject jsonObject = JSONObject.fromObject(jsonStr);
            if (null != jsonObject) {
                Object o = jsonObject.get("data");
                if (null != o) {
                    JSONObject res = (JSONObject) o;
                    Object summary = res.get("summary");
                    if (null != summary) {
                        JSONObject summaryJSON = (JSONObject) summary;
                        JSONArray jsonArray = summaryJSON.getJSONArray("items");
                        if (null != jsonArray) {
                            JSONObject result = (JSONObject) jsonArray.get(1);
                            String pv_value = result.getString("pv");
                            String uv_value = result.getString("uv");
                            webDriver.get("http://api.umeng.com/yesterday_data?appkey=592f6da245297d3eed001496&auth_token=n8FodCvgRIqBdX1JEztt");
                            String jsonApp = webDriver.getPageSource();
                            String jsonAppStr = jsonApp.substring(strHead.length(), jsonApp.length() - strLast.length());
                            JSONObject jsonObjectApp = JSONObject.fromObject(jsonAppStr);
                            if (null != jsonObjectApp) {
                                String uvIos = jsonObjectApp.getString("active_users");
                                String launchesIos = jsonObjectApp.getString("launches");
                                webDriver.get("http://api.umeng.com/yesterday_data?appkey=592f6e5a3eae255a0b000355&auth_token=n8FodCvgRIqBdX1JEztt");
                                String jsonAD = webDriver.getPageSource();
                                String jsonStrAD = jsonAD.substring(strHead.length(), jsonAD.length() - strLast.length());
                                JSONObject jsonObjectAD = JSONObject.fromObject(jsonStrAD);
                                if (null != jsonObjectAD) {
                                    String UvAD = jsonObjectAD.getString("active_users");
                                    String launchesAD = jsonObjectAD.getString("launches");
                                    map.put("uv", String.valueOf(Integer.valueOf(uv_value) + Integer.valueOf(uvIos) + Integer.valueOf(UvAD)));
                                    map.put("pv", String.valueOf(Integer.valueOf(pv_value) + Integer.valueOf(launchesIos) + Integer.valueOf(launchesAD)));
                                }
                            }
                        }
                    }
                }
            }
            String pedroWechatDate = WechatUtils.getPedroWeChatData(WechatUtils.getPedroAccessToken(), DateUtil.format(DateUtil.getYesterday(), SystemConstant.FORMAT_DATE_YYMMDD),DateUtil.format(DateUtil.getYesterday(),SystemConstant.FORMAT_DATE_YYMMDD));
            parseJson(pedroWechatDate, map);
        }

        if (map.get("uv") != null && map.get("pv") != null && map.get("miniUV") != null && map.get("miniPV") != null) {
            map.put("uv", String.valueOf(Integer.parseInt(map.get("uv")) + Integer.parseInt(map.get("miniUV"))));
            map.put("pv", String.valueOf(Integer.parseInt(map.get("pv")) + Integer.parseInt(map.get("miniPV"))));
        }

        webDriver.quit();
    }

    static void parseJson(String wechatDate, Map<String,String> map) {
        try{
            MiniprogramUv mini = new Gson().fromJson(wechatDate, MiniprogramUv.class);
            map.put("miniUV", String.valueOf(mini.getList().get(0).getVisit_uv()));
            map.put("miniPV", String.valueOf(mini.getList().get(0).getVisit_pv()));
        } catch (Exception e){
            map.put("miniUV", String.valueOf(0));
            map.put("miniPV", String.valueOf(0));
        }

    }

    /**
     * 登录模块
     */
    private static void userLogin(WebDriver driver, int shopid) throws Exception {
        List<String> userPass = getUP(shopid);
        if (shopid == 1 || shopid == 2 || shopid == 16) {
            driver.get(taobaourl);
            Thread.sleep(200);//等待0.2秒
            driver.switchTo().frame(0);
            WebElement usernameWebElement = driver.findElement(By.xpath("//*[@id=\"fm-login-id\"]"));
            usernameWebElement.sendKeys(userPass.get(0));
            WebElement passwordWebElement = driver.findElement(By.xpath("//*[@id=\"fm-login-password\"]"));
            passwordWebElement.sendKeys(userPass.get(1));
            //模拟滑动
            Thread.sleep(5000);
            WebElement btnWebElement = driver.findElement(By.xpath("//button[@class='fm-button fm-submit password-login']"));
            btnWebElement.click();
//            WebElement draggable = driver.findElement(By.id("nc_1_n1z"));//定位元素
//            Actions bu = new Actions(driver); // 声明action对象
//            bu.clickAndHold(draggable).build().perform(); // clickAndHold鼠标左键按下draggable元素不放
//            bu.moveByOffset(380, 2).perform(); // 平行移动鼠标
//            Thread.sleep(200);
//            bu.moveByOffset(400, 2).perform(); // 平行移动鼠标
//            Thread.sleep(200);
//            bu.moveByOffset(420, 2).perform(); // 平行移动鼠标
//            Thread.sleep(3000);
//            if (shopid == 1) {
//                WebElement btnWebElement1 = driver.findElement(By.xpath("/html/body/div[6]/div/div/div/div/span[4]/span"));
//                btnWebElement1.click();
//            } else if (shopid == 16) {
//                WebElement btnWebElement16 = driver.findElement(By.xpath("/html/body/div[6]/div/div/div/div/span[3]/span"));
//                btnWebElement16.click();
//            }
            Thread.sleep(3000);
        }else if (shopid == 4 || shopid == 19){
            driver.get(jdurl);
            Thread.sleep(200);//等待0.2秒
            WebElement loginWebElement = driver.findElement(By.xpath("//*[@id=\"main\"]/div[1]/div[1]/div/div/div[2]/a[5]"));
            loginWebElement.click();
            Thread.sleep(5000);//等待5秒
            driver.switchTo().frame(0);
            WebElement userLoginWebElement = driver.findElement(By.xpath("/html/body/div[2]/div[2]/a"));
            userLoginWebElement.click();
            Thread.sleep(5000);//等待5秒
            WebElement usernameWebElement = driver.findElement(By.xpath("//*[@id=\"loginname\"]"));
            usernameWebElement.clear();
            usernameWebElement.sendKeys(userPass.get(0));
            WebElement passwordWebElement = driver.findElement(By.xpath("//*[@id=\"nloginpwd\"]"));
            passwordWebElement.clear();
            passwordWebElement.sendKeys(userPass.get(1));
            WebElement btnWebElement = driver.findElement(By.xpath("//*[@id=\"loginsubmit\"]"));
            btnWebElement.click();
            Thread.sleep(5000);
            //模拟滑动
//            Thread.sleep(1000);
//            WebElement draggable = driver.findElement(By.xpath("//*[@id=\"JDJRV-wrap-loginsubmit\"]/div/div/div/div[2]/div[3]"));//定位元素
//            Actions bu = new Actions(driver); // 声明action对象
//            bu.clickAndHold(draggable).build().perform(); // clickAndHold鼠标左键按下draggable元素不放
//            bu.moveByOffset(380, 2).perform(); // 平行移动鼠标
//            Thread.sleep(200);
//            bu.moveByOffset(400, 2).perform(); // 平行移动鼠标
//            Thread.sleep(200);
//            bu.moveByOffset(420, 2).perform(); // 平行移动鼠标
            Thread.sleep(3000);
        }else if (shopid == 13 || shopid == 18){
            driver.get(redurl);
            Thread.sleep(1000);//等待0.2秒
            WebElement usernameWebElement = driver.findElement(By.xpath("//input[contains(@placeholder,'邮箱')]"));
            usernameWebElement.sendKeys(userPass.get(0));
            WebElement passwordWebElement = driver.findElement(By.xpath("//input[contains(@placeholder,'密码')]"));
            passwordWebElement.sendKeys(userPass.get(1));
            WebElement btnWebElement = driver.findElement(By.xpath("//button[contains(@owl,'login-submit')]"));
            btnWebElement.click();
            Thread.sleep(5000);
        }else if (shopid == 3 || shopid == 15){
            Thread.sleep(1000);
            driver.get(umengurl);
        }
    }
}
