package com.pvuv.pvuv.util;

import java.util.HashMap;
import java.util.Map;

public class SystemConstant {
    //登录类型
    public static final int LOGIN_TYPE_WEB = 0;
    public static final int LOGIN_TYPE_ANDROID = 1;
    public static final String COOKIE_USER_PRE = "ubaby_user_";
    public static final String COOKIE_PSW_PRE = "ubaby_psw_";

    //WEB SERVICE URL映射常量地址
    public static final String WS_URL_LOGIN = "/login/{accountCode}/{password}";
    public static final String WS_URL_LIST_ALLBRAND = "/listAllBrand/{token}";
    public static final String WS_URL_LIST_ALLCATEGORY = "/listAllCategory/{token}";
    public static final String WS_URL_LIST_ALLFOLDER = "/listAllFolder/{token}";
    public static final String WS_URL_LIST_BRAND_FOLDER = "/listBrandFolder/{brandId}/{token}";



    //URL映射常量地址
    public static final String URL_REALTIME_CONTROLLER = "/realtime";
    public static final String URL_TAOBAOMESSAGE_CONTROLLER = "/externalInterface";
    public static final String URL_WAREHOUSE_CONTROLLER = "/warehouse";
    public static final String URL_REALTIMEINTER_CONTROLLER = "/realtimeInterface";
    public static final String URL_API_CREATED = "/api/created";
    public static final String URL_USER_CONTROLLER = "/userController";
    public static final String URL_EMAIL_CONTROLLER = "/emailController";
    public static final String URL_FTP_CONTROLLER = "/ftpController";
    public static final String URL_SWITCH_CONTROLLER = "/switchController";
    public static final String URL_ROLE_CONTROLLER = "/roleController";
    public static final String URL_RESOURCE_CONTROLLER = "/resourceController";
    public static final String URL_MENU_CONTROLLER = "/menuController";
    public static final String URL_GROUP_CONTROLLER = "/groupController";
    public static final String URL_JOB_CONTROLLER = "/ckcjob";
    public static final String URL_JOB_SHOPEXCHANGE = "/shopExchange";
    public static final String URL_SCHEDULE_CONTROLLER = "/ckSchedule";
    public static final String URL_SHOP_CONTROLLER = "/shop";
    public static final String URL_CUSTOMER_CONTROLLER = "/customer";
    public static final String URL_COMMON = "/common";
    public static final String URL_TAOBAOAG_CONTROLLER ="/taobaoAG";
    public static final String URL_OA_CONTROLLER = "/oa";
    public static final String URL_CUSTOMER_LOG_CONTROLLER = "/customerlog";
    public static final String URL_PROMOTION_CONTROLLER= "/promotion";
    public static final String URL_SHOPMANAGER_CONTROLLER = "/shopManager";
    public static final String URL_JOBMANAGER_CONTROLLER = "/jobManager";
    public static final String URL_PRICEMANAGER_CONTROLLER = "/priceManager";
    public static final String URL_ALIPAYSTATEMENT_CONTROLLER = "/alipayStatement";
    public static final String URL_GOODS_CONTROLLER = "/goods";
    public static final String URL_WEEK_REPORT_CONTROLLER = "/weekReport";
    public static final String URL_INVENTORY_CONTROLLER = "/inventory";
    public static final String URL_MATCHPRODUCT_CONTROLLER = "/matchProduct";
    public static final String URL_PRODUCT_CONTROLLER = "/product";
    public static final String URL_DIVIDE_CONTROLLER = "/divide";
    public static final String URL_CATEGORY_CONTROLLER = "/category";
    public static final String URL_ORDER_LOG_CONTROLLER = "/orderLog";
    public static final String URL_ORDER_CONTROLLER = "/order";
    public static final String URL_SHIPPING_CONTROLLER = "/ship";
    public static final String URL_HISTORYORDER_CONTROLLER = "/historyOrder";
    public static final String URL_PM_CONTROLLER = "/pmController";
    public static final String URL_RETURN_CONTROLLER = "/return";
    public static final String URL_REPEAT_CONTROLLER = "/repeat";
    public static final String URL_VIP_CONTROLLER = "/vip";
    public static final String URL_SHORTSTOCK_CONTROLLER = "/shortStock";
    public static final String URL_UPPRODUCT_CONTROLLER = "/upproduct";
    public static final String URL_WECHATPAY_CONTROLLER = "/wechatPay";
    public static final String URL_RESERVE_CONTROLLER = "/reserve";
    public static final String URL_PRESALE_CONTROLLER = "/presale";
    public static final String URL_REPORT_CONTROLLER = "/report";
    public static final String URL_MERGE_ORDER_CONTROLLER = "/mergeOrder";
    public static final String URL_RETURNREPORT_CONTROLLER = "/returnReport";
    public static final String URL_USER_REGISTER = "/reg";
    public static final String URL_USER_LOGIN = "/login";
    public static final String URL_USER_LOGOUT = "/logout";
    public static final String URL_COMBOGRID = "/combogrid";
    public static final String URL_COMBOBOX = "/combobox";
    public static final String URL_DATAGRID = "/datagrid";
    public static final String URL_REMOVE = "/remove";
    public static final String URL_UPDATE_STATUS= "/updateStatus";
    public static final String URL_ADD = "/add";
    public static final String URL_EDIT = "/edit";
    public static final String URL_MODIFY_ROLE = "/modifyRole";
    public static final String URL_MODIFY_GROUP = "/modifyGroup";
    public static final String URL_MODIFY_PWD = "/modifyPwd";
    public static final String URL_CURRENT_USER_PWD = "/modifyCurrentUserPwd";
    public static final String URL_USER_INFO = "/userInfo";
    public static final String URL_TREE_GRID = "/treegrid";
    public static final String URL_ALLTREE_GRID = "/allTreeNode";
    public static final String URL_ORDER_HANGS="/taobaoTrade";
    public static final String URL_EDIT_TRADEADDRESS="/taobaoaddress";
    public static final String URL_GUAVA_CATCH = "/guava";
    //VIEW地址
    public static final String VIEW_USER_INFO = "user/userInfo";

    //常用格式
    public static final String FORMAT_DATE_YMDHMS = "yyyy-MM-dd HH:mm:ss";
    public static final String FORMAT_DATE_HH = "HH";
    public static final String FORMAT_DATE_YMDHMS_STRING = "yyyyMMddHHmmss";
    public static final String FORMAT_DATE_YMD = "yyyy-MM-dd";
    public static final String FORMAT_MONTH = "yyyy-MM";
    public static final String FORMAT_DATE_YYMMDD = "yyyyMMdd";
    public static final String FORMAT_DATE_YYMM = "yyyyMM";
    public static final String FORMAT_DATE_MDYHMS = "MM/dd/yy HH:mm";
    public static final String CRON_DATE_FORMAT  = "ss mm HH dd MM ? yyyy";


    //消息字符串
    public static final String MSG_REGISTER_SUCCESS = "注册成功！";
    public static final String MSG_DELETE_SUCCESS = "删除成功！";
    public static final String MSG_DELETE_FAIL = "删除失败！";
    public static final String MSG_LOGIN_SUCCESS = "登录成功！";
    public static final String MSG_LOGIN_FAIL = "登录失败！";
    public static final String MSG_ADD_SUCCESS = "添加成功！";
    public static final String MSG_ADD_FAIL = "添加失败！";
    public static final String MSG_EDIT_SUCCESS = "修改成功！";
    public static final String MSG_EDIT_FAIL = "修改失败！";
    public static final String MSG_RECORD_ALREADY_EXIST = "记录已经存在！";
    public static final String MSG_UPLOAD_SUCCESS = "上传成功！";
    public static final String MSG_UPLOAD_FAIL = "上传失败！";
    public static final String MSG_SUCCESS_DELIVERY = "发货成功！";
    public static final String MSG_FAILED_DELIVERY = "发货失败！";
    public static final String JOB_LAUNCH_FAIL ="Job启动失败！";
    public static final String JOB_LAUNCH_SUCCESS="Job启动成功！";
    public static final String JOB_CORRECTNESS_INFOR="请填写店铺与时间！";
    public static final String JOB_ERROR_INFO = "Job错误信息：";
    public static final String JOB_STOP_SUCCESS="已经停止了{0}个Job!";
    public static final String JOB_STOP_FAIL="停止Job失败，错误信息如下：";
    public static final String MSG_ORDEREXPORT_FAIL = "订单导出失败！";
    public static final String MSG_ORDEREXPORT_SUCCESS = "订单导出成功！";


    public static final String SHOP_ID_NOT_IN=" and shopid !=5 and shopid !=10 and shopid !=12 and shopid !=31";
    public static final String DAILY_REPORT_SHOP_ID_NOT_IN=" and shopid !=5 and shopid !=10 and shopid !=31 and shopid !=6 and shopid !=12 and !ISNULL(shopid)";
    public static final String PROMOTION="promotion_";

    // 品牌名字
    public static final String BRAND_CK="ck";
    public static final String BRAND_PEDRO="pedro";

    public static Map<String,String> kuaiDi100 = new HashMap<String, String>();
    static {
        kuaiDi100.put("sf","shunfeng");
        kuaiDi100.put("COD","jd");
        kuaiDi100.put("CSCOD","shunfeng");
        kuaiDi100.put("EMS","EMS");
        kuaiDi100.put("ZTO","zhongtong");
    }
}
