package com.pvuv.pvuv.util;

import net.sf.json.JSONObject;
import org.apache.commons.lang.StringUtils;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by villiam on 18/3/20.
 */
public class WechatUtils {

    private static final String access_token_url = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=wx072302256a82deb1&secret=13b1c66b86e402562249b9478b54732d";

    private static final String data_url = "https://api.weixin.qq.com/datacube/getweanalysisappiddailyvisittrend?access_token=";

    private static final String pedro_access_token_url = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=wx56ccb2900f39febe&secret=1c0fdee749bbafa0e15a7cdb58d3c9d5";

    private static final String pedro_data_url = "https://api.weixin.qq.com/datacube/getweanalysisappiddailyvisittrend?access_token=";


    public static String getAccessToken(){
        String token = "";
        String result = HttpUtils.get(access_token_url, null);
        JSONObject jsonResult = JSONObject.fromObject(result);
        if(StringUtils.isNotEmpty(result))
            token = jsonResult.getString("access_token");
        return token;
    }

    public static String getWeChatData(String token, String begin, String end){
        if(StringUtils.isNotEmpty(token)){
            Map<String, Object> parameterMap = new HashMap<String, Object>();

            JSONObject jsonObject = new JSONObject();
//            jsonObject.put("begin_date","20180318");
//            jsonObject.put("end_date","20180318");
            jsonObject.put("begin_date",begin);
            jsonObject.put("end_date",end);
            return HttpUtils.postWithBody(data_url + token, null, jsonObject.toString());
        }
        return null;
    }

    public static String getPedroAccessToken(){
        String token = "";
        String result = HttpUtils.get(pedro_access_token_url, null);
        JSONObject jsonResult = JSONObject.fromObject(result);
        if(StringUtils.isNotEmpty(result))
            token = jsonResult.getString("access_token");
        return token;
    }

    public static String getPedroWeChatData(String token, String begin, String end){
        if(StringUtils.isNotEmpty(token)){
            Map<String, Object> parameterMap = new HashMap<String, Object>();

            JSONObject jsonObject = new JSONObject();
//            jsonObject.put("begin_date","20180318");
//            jsonObject.put("end_date","20180318");
            jsonObject.put("begin_date",begin);
            jsonObject.put("end_date",end);
            return HttpUtils.postWithBody(pedro_data_url + token, null, jsonObject.toString());
        }
        return null;
    }

    public static void main(String args[]){
        System.out.println(getWeChatData(getAccessToken(), DateUtil.format(DateUtil.getYesterday(), SystemConstant.FORMAT_DATE_YYMMDD),DateUtil.format(DateUtil.getYesterday(),SystemConstant.FORMAT_DATE_YYMMDD)));
        System.out.println(getPedroWeChatData(getPedroAccessToken(), DateUtil.format(DateUtil.getYesterday(), SystemConstant.FORMAT_DATE_YYMMDD),DateUtil.format(DateUtil.getYesterday(),SystemConstant.FORMAT_DATE_YYMMDD)));
    }
}
